local colorsLib = require "../lib/colors.lua"

local button = {}
button.__index = button
button.__newindex = function() error("can't assign new var") end
button.__metatable = true

function createButton(x, y, w, h, text, bgColor, textColor, e)
	assert(type(text) == "string", "bad arg: text not string")
	assert(type(bgColor) == "string" or "table",
		"bad arg: bgColor not string or table")
	assert(type(textColor) == "string" or "table",
		"bad arg: textColor not string or table")
	assert(type(e) == "function", "bad arg: e not a function")
	local b = {
		x = x,
		y = y,
		w = w,
		h = h,
		text = {
			line = text,
			x = x + 5,
			y = y + 5,
			color = colorsLib.pickColor(textColor),
		},
		bgColor = colorsLib.pickColor(bgColor),
		e = e,
	}
	return setmetatable(b, button)
end

function button:sendEvent()
	table.insert(events, self.e)
end

function button:draw()
	love.graphics.setRenderTarget(fb)
	love.graphics.setColor(
		self.bgColor.r,
		self.bgColor.g,
		self.bgColor.b,
		self.bgColor.a)
	love.graphics.rectangle(
		"fill",
		self.x,
		self.y,
		self.w,
		self.h)
	love.graphics.setColor(
		self.text.color.r,
		self.text.color.g,
		self.text.color.b,
		self.text.color.a)
	love.graphics.print(
		self.text.line,
		self.text.x,
		self.text.y)
	love.graphics.setRenderTarget()
end
