local buttonLib = require "./obj/button.lua"
local slideLib = require "./obj/slide.lua"

local slideIndex = 1

local function load()
	local BUTTONWIDTH = 20
	local BUTTONHEIGHT = 10
	local buttonBGColor = "white"
	local buttonTextColor = "black"
	local slideBGColor = "black"
	local slideTextColor = "white"
	events = {}
	buttons = {}
	buttons.prev = createButton(
		10,
		SCREENSIZE - BUTTONHEIGHT - 10,
		BUTTONWIDTH,
		BUTTONHEIGHT,
		"PREV",
		buttonBGColor,
		buttonTextColor,
		function()
			if slideIndex < #slides then
				slideIndex = slideIndex + 1
			end
		end)
	buttons.next = createButton(
		50,
		SCREENSIZE - BUTTONHEIGHT - 10,
		BUTTONWIDTH,
		BUTTONHEIGHT,
		"NEXT",
		buttonBGColor,
		buttonTextColor,
		function()
			if slideIndex > 0 then
				slideIndex = slideIndex - 1
			end
		end)
	buttons.start = createButton(
		SCREENSIZE - BUTTONWIDTH - 10,
		SCREENSIZE - BUTTONHEIGHT - 10,
		BUTTONWIDTH,
		BUTTONHEIGHT,
		"START",
		buttonBGColor,
		buttonTextColor,
		function()
			-- TODO: start game
		end)
	buttons.retry = createButton(
		(SCREENSIZE / 2) - (BUTTONWIDTH / 2),
		(SCREENSIZE / 2) - (BUTTONHEIGHT / 2),
		BUTTONWIDTH,
		BUTTONHEIGHT,
		"RETRY",
		buttonBGColor,
		buttonTextColor,
		function()
			-- TODO: start game
		end)
	slides = {}
	slides.tut = {}
	slides.tut[1] = createSlide(
		0,
		0,
		SCREENSIZE,
		SCREENSIZE,
		"You are the white dot. You are late for work, but really hungry. Eat as much food as you can within five seconds.",
		slideBGColor,
		slideTextColor)
	slides.tut[2] = createSlide(
		0,
		0,
		SCREENSIZE,
		SCREENSIZE,
		"Control your movement with the mouse. When you touch a piece of food. You eat it.",
		slideBGColor,
		slideTextColor)
	slides.tut[3] = createSlide(
		0,
		0,
		SCREENSIZE,
		SCREENSIZE,
		"Good (green) food increases the amount of time you have to eat, but also makes you fatter.",
		slideBGColor,
		slideTextColor)
	slides.tut[4] = createSlide(
		0,
		0,
		SCREENSIZE,
		SCREENSIZE,
		"Bad (red) good decreases the amount of time you have, but you immediately spit it out, so you don't get fatter.",
		slideBGColor,
		slideTextColor)
end

local function update(dt)
	for k,v in ipairs(events) do
		v()
		table.remove(events, k)
	end
end

local function draw()
	slides.tut[slideIndex]:draw()
	buttons.prev:draw()					-- attempt to call method 'draw' (a nil value)
	--~ for k,v in pairs(buttons) do
		--~ if k ~= retry then
			--~ buttons[k]:draw()
		--~ end
	--~ end
	love.graphics.draw(fb, 0, 0)
end

menu = {}
menu.load = load
menu.update = update
menu.draw = draw

return menu
